package com.yaozhitech.spring5.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.yaozhitech.spring5.annotation.IgnoreClientToken;
import com.yaozhitech.spring5.provider.AdminProvider;
import com.yaozhitech.spring5.utils.JwtUtils;

@RestController
@RequestMapping("/order")
public class OrderController {
	
	@Autowired
	private AdminProvider adminProvider;
	
	@Value("${spring.application.name}")
    private String applicationName;
	
	@Value("${auth.client.secret}")
    private String clientSecret;

	@GetMapping("/{id}")
	public ResponseEntity<String> read(@PathVariable Long id) {
		return ResponseEntity.ok(adminProvider.admin(id));
	}
	
	@IgnoreClientToken
	@GetMapping("/token")
	public ResponseEntity<String> token() {
		return ResponseEntity.ok(JwtUtils.sign(applicationName + "." + clientSecret, JwtUtils.generateSalt(), 3600));
	}
}
